local	AddonName, Version , ModulName = ... , GetAddOnMetadata ( ... , "Version" ) , "Currencies Shadowlands"
local	Addon = CreateFrame ( "Frame" , nil , UIParent , BackdropTemplateMixin and "BackdropTemplate" ); Addon : SetAllPoints () ; 
	-------------------------------------------------------------------------------------------
        -- REGISTER EVENTS ------------------------------------------------------------------------
        -------------------------------------------------------------------------------------------
	Addon : RegisterEvent ( "ADDON_LOADED" );
	Addon : RegisterEvent ( "CURRENCY_DISPLAY_UPDATE" );
	-------------------------------------------------------------------------------------------
        -- Get Libraries  -------------------------------------------------------------------------
        -------------------------------------------------------------------------------------------
	local LibQTip		= LibStub : GetLibrary ( "LibQTip-1.0" );
	local LibDataBroker	= LibStub : GetLibrary ( "LibDataBroker-1.1" );
	-------------------------------------------------------------------------------------------
        -- ADDON VARIABLES ------------------------------------------------------------------------
        -------------------------------------------------------------------------------------------
	local WrapHex		= WrapTextInColorCode;
	local onText , offText	= WrapHex ( "On" , "ff" .. "009900" ) , WrapHex ( "Off" , "ff" .. "FF0000" );
	local RightButton	= " |T341461:20:16:0:-1:512:512:12:66:333:411|t ";
	local nocurrency	= "No Selected Currency";
	-------------------------------------------------------------------------------------------
        -- ADDON DEFAULT DATABASE -----------------------------------------------------------------
        -------------------------------------------------------------------------------------------
	local DefaultDB = {
	      {id = 1931, category = 245, type = "currency", ldb = true,  name = "Cataloged Research",},
	      {id = 1813, category = 245, type = "currency", ldb = true,  name = "Reservoir Anima",},
	      {id = 1767, category = 245, type = "currency", ldb = true,  name = "Stygia",},
	      {id = 1810, category = 245, type = "currency", ldb = false, name = "Redeemed Soul",},
	      {id = 1885, category = 245, type = "currency", ldb = false, name = "Grateful Offering",},

	      {id = 1816, category = 245, type = "currency", ldb = false, name = "Sinstone Fragments",},
	      {id = 1819, category = 245, type = "currency", ldb = false, name = "Medallion of Service",},
	      {id = 1820, category = 245, type = "currency", ldb = false, name = "Infused Ruby",},
	      {id = 1828, category = 245, type = "currency", ldb = false, name = "Soul Ash",},
	      {id = 1904, category = 245, type = "currency", ldb = false, name = "Tower Knowledge",},
	      {id = 1906, category = 245, type = "currency", ldb = false, name = "Soul Cinders",},
	      {id = 1977, category = 245, type = "currency", ldb = false, name = "Stygian Ember",},

      	      {id = 1191, category = 245, type = "currency", ldb = false, name = "Valor",},
	      {id = 1754, category = 245, type = "currency", ldb = false, name = "Argent Commendation",},


	      {id = 1829, category = 245, type = "currency", ldb = false, name = "Renown-Kyrian",},			-- Hidden
	      {id = 1830, category = 245, type = "currency", ldb = false, name = "Renown-Venthyr",},			-- Hidden
	      {id = 1831, category = 245, type = "currency", ldb = false, name = "Renown-NightFae",},			-- Hidden
	      {id = 1832, category = 245, type = "currency", ldb = false, name = "Renown-Necrolord",},			-- Hidden

	      {id = 1863, category = 245, type = "currency", ldb = false, name = "Redeemed Soul-Kyrian",},		-- Hidden
	      {id = 1864, category = 245, type = "currency", ldb = false, name = "Redeemed Soul-Venthyr",},		-- Hidden
	      {id = 1865, category = 245, type = "currency", ldb = false, name = "Redeemed Soul-Night Fae",},		-- Hidden
	      {id = 1866, category = 245, type = "currency", ldb = false, name = "Redeemed Soul-Necrolord",},		-- Hidden

	      {id = 1859, category = 245, type = "currency", ldb = false, name = "Reservoir Anima-Kyrian",},		-- Hidden
	      {id = 1860, category = 245, type = "currency", ldb = false, name = "Reservoir Anima-Venthyr",},		-- Hidden
	      {id = 1861, category = 245, type = "currency", ldb = false, name = "Reservoir Anima-Night Fae",},		-- Hidden
	      {id = 1862, category = 245, type = "currency", ldb = false, name = "Reservoir Anima-Necrolord",},		-- Hidden

	      {id = 1867, category = 245, type = "currency", ldb = false, name = "Sanctum Architect-Kyrian",},		-- Hidden
	      {id = 1868, category = 245, type = "currency", ldb = false, name = "Sanctum Architect-Venthyr",},		-- Hidden
	      {id = 1869, category = 245, type = "currency", ldb = false, name = "Sanctum Architect-Night Fae",},	-- Hidden
	      {id = 1870, category = 245, type = "currency", ldb = false, name = "Sanctum Architect-Necrolord",},	-- Hidden

	      {id = 1871, category = 245, type = "currency", ldb = false, name = "Sanctum Anima Weaver-Kyrian",},	-- Hidden
	      {id = 1872, category = 245, type = "currency", ldb = false, name = "Sanctum Anima Weaver-Venthyr",},	-- Hidden
	      {id = 1873, category = 245, type = "currency", ldb = false, name = "Sanctum Anima Weaver-Night Fae",},	-- Hidden
	      {id = 1874, category = 245, type = "currency", ldb = false, name = "Sanctum Anima Weaver-Necrolord",},	-- Hidden

	      {id = 1743, category = 245, type = "currency", ldb = false, name = "Fake Anima for Quest Tracking",},	-- Hidden
	      {id = 1802, category = 245, type = "currency", ldb = false, name = "Shadowlands PvP Weekly Reward Progress",},

	}
	local Text = ""
	-------------------------------------------------------------------------------------------
        -- DataBroker FUNCTIONS ------------------------------------------------------------------------
        -------------------------------------------------------------------------------------------
	 local LDB	 = LibDataBroker : GetDataObjectByName ( "(D) " .. ModulName ) or LibDataBroker : NewDataObject ( "(D) " .. ModulName , { type = "data source" } )
	       LDB.title = "|cffFF0000 (D) |r" ..  "|cff0080FF" .. ModulName .. "|r " ..  "|cffFFFFFF" .. Version .. "|r ";
	       LDB.label = "(D) " .. ModulName;

function LDB.OnEnter ( self )
	 if (not inCombat or inCombat == "block") and InCombatLockdown() then return end
		 LibQTip : Release ( self.QTip ); self.QTip = nil;
		 QTip = LibQTip : Acquire ( ModulName .. "Tooltip" , 4 , "LEFT" , "RIGHT" , "RIGHT" ); self.QTip = QTip;

		 QTip : SetFrameStrata ( "FULLSCREEN" )
		 QTip : SmartAnchorTo ( self )
		 QTip : EnableMouse ( true )
		 QTip : SetAutoHideDelay ( 0.1 , self )
	 -------------------------------------------------------------------------------------------
	 -- Tooltip Header -------------------------------------------------------------------------
	 -------------------------------------------------------------------------------------------
	      -- Setup Header Font Size
		 QTip : SetFont ( GameTooltipHeaderText )
		 QTip : AddSeparator ( 1 , 1 , 1 , 1 , 0 )
	      -- Add Line
		 row , column = QTip : AddLine ( "" )
		 QTip : SetCell ( row , 1 , GetAddOnMetadata ( AddonName , "Title" ) , "LEFT", 1)
		 QTip : SetColumnTextColor ( 1 , 1 , 0 , 0 , 1 )
		 QTip : SetCell ( row , 3 , "|cffFFFFFF" .. Version .. "|r" , "RIGHT", 1)
		 QTip : AddSeparator ( 2 , 1 , 1 , 1 , 0 )
	      -- Add Separator	Line ( thickness , r , g , b , alpha)
		 row , column = QTip : AddSeparator ( 1 )
		 QTip.lines[row]:SetBackdrop({bgFile = "Interface/Buttons/WHITE8X8", tile = true })
		 QTip.lines[row]:SetBackdropColor ( 1 , 0.8 , 0 , 1)
	      -- Setup Tooltip Font Size				 
		 QTip : SetFont ( GameTooltipText )
	 -------------------------------------------------------------------------------------------
	 -- Currencies -------------------------------------------------------------------------
	 -------------------------------------------------------------------------------------------
		 QTip : AddSeparator ( 1 , 1 , 1 , 1 , 0 )
		 
		 for k , v in pairs( CurrenciesShadowlands ) do
			local TooltipInfo = C_CurrencyInfo.GetCurrencyInfo ( CurrenciesShadowlands[k].id )
			if TooltipInfo.discovered then 
				row , column = QTip : AddLine ( "" )
				QTip : SetLineTextColor ( row , 1 , 1 , 1 , 1 )
				QTip : SetCell ( row , 1 , "|T" .. TooltipInfo.iconFileID .. ":20:20|t " .. TooltipInfo.name , "LEFT" , 1)

				if TooltipInfo.maxQuantity >0 
				   then QTip : SetCell ( row , 2 , TooltipInfo.quantity .. "/" .. TooltipInfo.maxQuantity , "RIGHT" , 1)
				   else QTip : SetCell ( row , 2 , TooltipInfo.quantity , "RIGHT" , 1)
				end
				
				QTip : SetCell ( row , 3 , CurrenciesShadowlands[k].ldb  and onText or offText , "RIGHT" , 1)
				QTip : SetLineScript( row , 'OnMouseDown' , function (self, button) 
				       CurrenciesShadowlands[k].ldb = not CurrenciesShadowlands[k].ldb;
				       self.cells[3].fontString : SetText ( CurrenciesShadowlands[k].ldb  and onText or offText , "RIGHT" )
				       Addon : DataObjectUpdate ( CurrenciesShadowlands )
				end)

				QTip : SetLineScript( row , 'OnMouseUp' , function (self, button) 
				       LibQTip : Release ( self.QTip ); self.QTip = nil;
				end)
			end
		 end

		 QTip : AddSeparator ( 1 , 1 , 1 , 1 , 0 )
	 -------------------------------------------------------------------------------------------
	 -- Features
	 -------------------------------------------------------------------------------------------
		  row , column = QTip : AddSeparator ( 1 )
		  QTip.lines[row]:SetBackdrop({bgFile = "Interface/Buttons/WHITE8X8", tile = true })
		  QTip.lines[row]:SetBackdropColor ( 1 , 0.8 , 0 , 1)

		  QTip : AddSeparator ( 5 , 1 , 1 , 1 , 0 )

		  row , column = QTip : AddLine ( "" )
		  QTip : SetCell ( row , 1 , "Click on the Currency to Toggle " .. onText .. "/" .. offText , "CENTER" , 3)

		  QTip : AddSeparator ( 5 , 1 , 1 , 1 , 0 )
		  
		  row , column = QTip : AddLine ( "" )
		  QTip : SetCell ( row , 1 , RightButton .. "Click + CTRL + SHIFT Reset to Default" , "CENTER" , 3)
		  
		  row , column = QTip : AddLine ( "" )
		  QTip : SetCell ( row , 1 , WrapHex ( "The user interface will reload!" , "ff" .. "FF0000" ) , "CENTER" , 3)

		  QTip : AddSeparator ( 5 , 1 , 1 , 1 , 0 )
	 -------------------------------------------------------------------------------------------
	 -- Copyright
	 -------------------------------------------------------------------------------------------
	       -- Add Separator	Line ( thickness , r , g , b , alpha)			 
		  row , column = QTip : AddSeparator ( 1 )
		  QTip.lines[row]:SetBackdrop({bgFile = "Interface/Buttons/WHITE8X8", tile = true })
		  QTip.lines[row]:SetBackdropColor ( 0.8 , 0 , 0 , 1) -- RED

		  row , column = QTip : AddLine ( "" )
		  QTip : SetCell ( row , 1 , WrapHex ( "Coded by " , "ff" .. "3399FF" ) .. WrapHex ( "Devil " , "ff" .. "FF0000" ).. WrapHex ( "(C)" , "ff" .. "FFFFFF" ) , "RIGHT" , 3)
	 -------------------------------------------------------------------------------------------
	 -- Show Tooltip
	 -------------------------------------------------------------------------------------------
		  QTip : Show ( )
	 end

	 function LDB.OnClick ( self, button , ...) 
		if ( button == "RightButton" and IsShiftKeyDown() and IsControlKeyDown() ) then
			CurrenciesShadowlands = DefaultDB
		end
		ReloadUI ();
	 end
	 -------------------------------------------------------------------------------------------
         -- ADDON FUNCTIONS ------------------------------------------------------------------------
         -------------------------------------------------------------------------------------------
function Addon : DataObjectUpdate ( database )
		 Text = ""
		 for k , v in pairs ( database ) do
		     local info = C_CurrencyInfo.GetCurrencyInfo ( database[k].id )
		     local icon = "|T" .. info.iconFileID .. ":20:20|t"
		     if database[k].ldb and info.discovered and info.quantity > 0 then Text = Text .. icon .. " " ..info.quantity .. " " end
		 end

		LDB.text = (Text ~= "") and Text or nocurrency;
end
	 -------------------------------------------------------------------------------------------
         -- EVENT FUNCTIONS ------------------------------------------------------------------------
         -------------------------------------------------------------------------------------------
	 Addon : SetScript ( "OnEvent", function ( self , event, ... ) 

		 if event == "ADDON_LOADED" then 
	
			-- ADDON DATABASE CHECK ----------------------------------------------------------	
			if ( not CurrenciesShadowlands ) then CurrenciesShadowlands = {} end;			
			-- COPY DEFAULT DATABASE ---------------------------------------------------------
			for k in pairs( DefaultDB ) do if (CurrenciesShadowlands[k]) == nil  then CurrenciesShadowlands[k] = DefaultDB[k]; end end
				 
			Addon : DataObjectUpdate ( CurrenciesShadowlands );
			-- ADDON LOADED MESSAGE ----------------------------------------------------------
			print ( "|cffFF0000(D) |r" .. ModulName .. " |cff0080FF" .. Version .. "|r Loaded ... " );
			-- UNREGISTER EVENT
			Addon : UnregisterEvent ( "ADDON_LOADED" );
		else
			Addon : DataObjectUpdate ( CurrenciesShadowlands );
		end
	end)